package cn.iocoder.yudao.module.system.controller.admin.positionmap.dto;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.ToString;

@Schema(description = "管理后台 - 仓库点位地图子表 - 节点基础属性")
@Data
public class NodeBaseDTO {
    @Schema(description = "id")
    private Long id;

    @Schema(description = "仓库点位地图表id")
    private Long positionMapId;

    @Schema(description = "库区id(自定义)")
    private Long areaId;

    @Schema(description = "巷道id(自定义)")
    private Long laneId;

    @Schema(description = "坐标x轴")
    private String locationX;

    @Schema(description = "坐标y轴")
    private String locationY;

    @Schema(description = "类型 1.路径点位 2.库位点 3.充电桩 4.停车点 5.区域变更点 6.等待点 --- 后续补充", example = "1")
    private Integer type;

    @Schema(description = "对应各个类型的独有属性Json格式 例如（{库位长度:1,库位宽度:2,库位方向:单向}）", example = "1")
    private String dataJson;

}
