package cn.iocoder.yudao.module.system.controller.admin.positionmap.vo;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.*;
import java.util.*;
import org.springframework.format.annotation.DateTimeFormat;
import java.time.LocalDateTime;
import com.alibaba.excel.annotation.*;

@Schema(description = "管理后台 - 仓库点位地图子表 Response VO")
@Data
@ExcelIgnoreUnannotated
public class PositionMapItemRespVO {

    @Schema(description = "主键ID", requiredMode = Schema.RequiredMode.REQUIRED, example = "31007")
    @ExcelProperty("主键ID")
    private Long id;

    @Schema(description = "仓库点位地图表id", example = "30963")
    @ExcelProperty("仓库点位地图表id")
    private Long positionMapId;

    @Schema(description = "库区id(自定义)", example = "30963")
    @ExcelProperty("库区id(自定义)")
    private Long areaId;

    @Schema(description = "巷道id(自定义)", example = "30963")
    @ExcelProperty("巷道id(自定义)")
    private Long laneId;

    @Schema(description = "坐标x轴")
    @ExcelProperty("坐标x轴")
    private String locationX;

    @Schema(description = "坐标y轴")
    @ExcelProperty("坐标y轴")
    private String locationY;

    @Schema(description = "类型 1.路径点位 2.库位点 3.充电桩 4.停车点 5.区域变更点 6.等待点  --- 后续补充", example = "1")
    @ExcelProperty("类型 1.路径点位 2.库位点 3.充电桩 4.停车点 5.区域变更点 6.等待点 --- 后续补充")
    private Integer type;

    @Schema(description = "对应各个类型的独有属性Json格式 例如（{库位长度:1,库位宽度:2,库位方向:单向}）", example = "1")
    private String dataJson;

    @Schema(description = "创建时间", requiredMode = Schema.RequiredMode.REQUIRED)
    @ExcelProperty("创建时间")
    private LocalDateTime createTime;

}
