package cn.iocoder.yudao.module.system.dal.mysql.houselocation;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.module.system.controller.admin.houselocation.vo.WareHouseLocationPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.houselocation.vo.WareHouseLocationRespVO;
import cn.iocoder.yudao.module.system.controller.admin.houselocation.vo.WareHouseLocationVO;
import cn.iocoder.yudao.module.system.dal.dataobject.houselocation.WareHouseLocationDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import javax.validation.constraints.NotNull;
import java.util.List;
import java.util.Set;

/**
 * 库位 Mapper
 *
 * @author 陈宾顺
 */
@Mapper
public interface WareHouseLocationMapper extends BaseMapperX<WareHouseLocationDO> {

    default PageResult<WareHouseLocationDO> selectPage(WareHouseLocationPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<WareHouseLocationDO>()
                .eqIfPresent(WareHouseLocationDO::getLaneId, reqVO.getLaneId())
                .likeIfPresent(WareHouseLocationDO::getLaneName, reqVO.getLaneName())
                .eqIfPresent(WareHouseLocationDO::getAreaId, reqVO.getAreaId())
                .likeIfPresent(WareHouseLocationDO::getAreaName, reqVO.getAreaName())
                .eqIfPresent(WareHouseLocationDO::getLocationNo, reqVO.getLocationNo())
                .likeIfPresent(WareHouseLocationDO::getGroupName, reqVO.getGroupName())
                .eqIfPresent(WareHouseLocationDO::getLocationYaw, reqVO.getLocationYaw())
                .eqIfPresent(WareHouseLocationDO::getSkuInfo, reqVO.getSkuInfo())
                .eqIfPresent(WareHouseLocationDO::getSkuBatch, reqVO.getSkuBatch())
                .eqIfPresent(WareHouseLocationDO::getSkuNumber, reqVO.getSkuNumber())
                .eqIfPresent(WareHouseLocationDO::getTrayInfo, reqVO.getTrayInfo())
                .eqIfPresent(WareHouseLocationDO::getLocationEnable, reqVO.getLocationEnable())
                .eqIfPresent(WareHouseLocationDO::getLocationLock, reqVO.getLocationLock())
                .eqIfPresent(WareHouseLocationDO::getLocationUseStatus, reqVO.getLocationUseStatus())
                .eqIfPresent(WareHouseLocationDO::getLocationX, reqVO.getLocationX())
                .eqIfPresent(WareHouseLocationDO::getLocationY, reqVO.getLocationY())
                .eqIfPresent(WareHouseLocationDO::getLocationWide, reqVO.getLocationWide())
                .eqIfPresent(WareHouseLocationDO::getLocationDeep, reqVO.getLocationDeep())
                .eqIfPresent(WareHouseLocationDO::getLocationHeight, reqVO.getLocationHeight())
                .eqIfPresent(WareHouseLocationDO::getLocationDefaultHeight, reqVO.getLocationDefaultHeight())
                .eqIfPresent(WareHouseLocationDO::getLocationTotalHeight, reqVO.getLocationTotalHeight())
                .eqIfPresent(WareHouseLocationDO::getLocationTrayHeight, reqVO.getLocationTrayHeight())
                .eqIfPresent(WareHouseLocationDO::getLocationStorey, reqVO.getLocationStorey())
                .eqIfPresent(WareHouseLocationDO::getLocationType, reqVO.getLocationType())
                .eqIfPresent(WareHouseLocationDO::getLocationNumber, reqVO.getLocationNumber())
                .eqIfPresent(WareHouseLocationDO::getTaskId, reqVO.getTaskId())
                .betweenIfPresent(WareHouseLocationDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(WareHouseLocationDO::getId));
    }

    /**
     * 查询空闲的库位id
     * @param type 类型（1：库位、2：线库、 3：区域）
     * @param id 库位/线库/区域
     * @return
     */
    WareHouseLocationDO selectByTypeAndId(@Param("locationUseStatus") Integer locationUseStatus,
                           @Param("takeType") Integer takeType,
                           @Param("id")  Long id,
                           @Param("locationIds") List<Long> locationIds,
                           @Param("mapIds") Set<Long> mapIds);

    /**
     * 普通查询(未删除)
     * @param wareHouseLocationDO
     * @return
     */
    WareHouseLocationDO queryAllByLimit(WareHouseLocationDO wareHouseLocationDO);

    /**
     * 更新库位锁定状态
     * @param id
     * @param locationLock
     */
    void updateLocationLockStatus(@Param("id") Long id,
                                  @Param("locationLock") int locationLock,
                                  @Param("taskId") Long taskId);

    /**
     * 查询库位
     * @param query
     * @param locationIds
     * @return
     */
    List<WareHouseLocationDO> selectLocations(@Param("query") WareHouseLocationDO query,
                                              @Param("locationIds") List<Long> locationIds,
                                              @Param("mapIds")  Set<Long> mapIds);

    void updateLocationLockList( @Param("locationIds") List<Long> locationIds,
                                 @Param("taskId") Long taskId);

    /**
     * 根据类型查库位/线库/区域
     * @param requestVO
     * @return
     */
    List<WareHouseLocationRespVO> getLocationByName(WareHouseLocationVO requestVO);
}